<template>
  <div @click="showDetails" :class="{ person: true, center, large }">
    <q-img class="image" :src="data.image" aspect-ratio="1" />
    <div class="person-info">
      <div style="margin: 12px; margin-left: 22px">
        {{ data.nick }},
        <div
          :class="{
            'login-indicator': true,
            active: data.loggedIn,
            'not-active': !data.loggedIn,
          }"
        ></div>
        {{ data.age }}
        <div class="city">{{ data.city }}</div>
      </div>
    </div>
  </div>
</template>
<script setup lang="ts">
import { useRouter } from 'vue-router';

export interface PersonComponentProps {
  data: {
    loggedIn: boolean;
    age: number;
    city?: string;
    nick: string;
    image: string;
    lazyImage?: string;
  };
  center?: boolean;
  large?: boolean;
  menu?: string;
}

const props = withDefaults(defineProps<PersonComponentProps>(), {});

const router = useRouter();
// const route = useRoute();

// Method to handle showing details
function showDetails() {
  router.push({
    path: '/personDetails',
    query: { nick: props.data.nick, menu: props.menu },
  });
}
</script>
<style scoped lang="scss">
.image {
  width: 100%;
  height: auto;
}
.person {
  width: 80%;
  transform: translateX(41px);

  color: rgba(0, 0, 0, 0.6);

  @media (min-width: 960px) {
    width: 80%;
    height: auto;
    // height: 250px;
  }

  .person-info {
    // position: relative;
    // z-index: 9999;
    font-size: 14px;
    height: 73px;
    width: calc(120% + 2px);
    left: -17px !important;
    font-size: 18px;
  }

  img {
    width: 70%;
  }

  @media (min-width: 960px) {
    .image {
      transition: all 0.2s ease-out;
      transform: scale(1);
      filter: grayscale(37%) opacity(92%) saturate(40%);

      &:hover {
        transition: all 1s ease-in;
        transform: scale(1.2);
        filter: none;
      }
    }
  }

  .person-info {
    z-index: 100;
    position: relative;
    // left: 0px;
    // width: 94%;
    padding: 6px;
    display: flex;
    flex-direction: column;
    justify-content: flex-end;
    padding: 6px;
    background: rgba(255, 255, 255, 1);

    & > * {
      z-index: 1;
      background: white;
      width: 201px;
      transform: translate(-8px, -8px);
    }

    * {
      display: flex;
      flex-direction: row;
    }

    .login-indicator {
      position: relative;
      left: -5px;
      border-radius: 100%;
      background: rgba(0, 200, 0, 0.7);
      height: 9px;
      width: 9px;
      margin: 2px;

      &.active {
        background: rgba(0, 200, 0, 0.7);
      }

      &.not-active {
        background: rgba(100, 100, 100, 0.5);
      }
    }

    .city {
      margin-left: auto;
      color: rgba(100, 100, 100, 0.8);
      // font-size: 13px;
    }
  }
}
</style>
